﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
' Base64EcondeDecodeImage - Code module
' Author:	MarcoRome

#Region VERSIONS 
' 1.1
'	Added ImageToString method, which is identical to Base64ImageToString,
'		but its name is more "correct". Kept Base64ImageToString for backward compatibility.
'	Added ImageToString2 method, which requires a B4XBitmap parameter.
'	Renamed variable name "convert" to mStringUtils
'		and declared it as Private in Process_Globals.
'	Added B4XBitmapToBytes private method - used by ImageToString2.
'	Added some Regions.
' 1.0
#End Region

Sub Process_Globals
	Private mStringUtils As StringUtils
End Sub

#Region PUBLIC METHODS 

Public Sub Base64StringToImage(s As String) As B4XBitmap
	Dim mStringUtils As StringUtils
	Dim bytes() As Byte = mStringUtils.DecodeBase64(s)
	Dim In As InputStream
	In.InitializeFromBytesArray(bytes, 0, bytes.Length)
   #if B4A or B4i
		Dim bmp As Bitmap
		bmp.Initialize2(In)
		In.Close
		Return bmp
   #else if B4J
	 	Dim bmp As Image
		bmp.Initialize2(In)
		In.Close
		Return bmp
   #end if
End Sub

Public Sub Base64ImageToString(Dir As String, Filename As String) As String 
	Return mStringUtils.EncodeBase64(Bit.InputStreamToBytes(File.OpenInput(Dir, Filename)))
End Sub

Public Sub ImageToString(Dir As String, Filename As String) As String 
	Return mStringUtils.EncodeBase64(Bit.InputStreamToBytes(File.OpenInput(Dir, Filename)))
End Sub

Public Sub ImageToString2(xBitmap As B4XBitmap) As String 
	Return mStringUtils.EncodeBase64(B4XBitmapToBytes(xBitmap))
End Sub

Public Sub ValidBase64(text As String) As Boolean
	If Regex.IsMatch("^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$", text.Trim) And text.Length > 3  Then
		Return True
	Else
		Return False
	End If
End Sub

#End Region

#Region PRIVATE METHODS 

Private Sub B4XBitmapToBytes(xBitmap As B4XBitmap) As Byte()
	Dim Out As OutputStream
	Out.InitializeToBytesArray(0)
	xBitmap.WriteToStream(Out, 100, "PNG")
	Dim Buffer() As Byte = Out.ToBytesArray
	Out.Close
	Return Buffer
End Sub

#End Region
